{
    

    TGridView  Delphi IDE

    . , 1997-2001
  E-mail: roman@sar.nnov.ru
}

unit Ex_RegGrid;

{$I EX.INC}

interface

uses
  Windows, SysUtils, Classes, Forms, Dialogs, TypInfo, DsgnIntf;

type

{ TGridEditor }

  TGridEditor = class(TDefaultEditor)
  private
    FCollection: TCollection;
    procedure FindCollectionEditor(PropertyEditor: TPropertyEditor);
  protected
    procedure EditProperty(PropertyEditor: TPropertyEditor; var Continue, FreeEditor: Boolean); override;
    procedure ShowCollectionEditor(ACollection: TCollection);
  public
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

{ TGridColumnsProperty }

  TGridColumnsProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

{ TGridHeaderProperty }

  TGridHeaderProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

{ TDBGridFieldNameProperty }

  TDBGridFieldNameProperty = class(TStringProperty)
  public
    function GetAttributes: TPropertyAttributes; override;
    procedure GetValues(Proc: TGetStrProc); override;
  end;

procedure Register;

implementation

uses
  Ex_Grid, Ex_GridC, Ex_GridH, Ex_Inspector, Ex_DBGrid;

{ TGridEditor }

procedure TGridEditor.FindCollectionEditor(PropertyEditor: TPropertyEditor);
var
  P: PTypeInfo;
begin
  {    ,   FCollection 
      nil }
  if FCollection <> nil then
  begin
    P := PropertyEditor.GetPropType;
    {      }
    if (P <> nil) and (P.Kind = tkClass) and (CompareText(P.Name, FCollection.ClassName) = 0) then
    begin
      PropertyEditor.Edit;
      FCollection := nil;
    end;
  end;
  {        }
  PropertyEditor.Free;
end;

procedure TGridEditor.EditProperty(PropertyEditor: TPropertyEditor; var Continue, FreeEditor: Boolean);
begin
  inherited EditProperty(PropertyEditor, Continue, FreeEditor);
  {       Delphi   
     Edit  TDefaultEditor. TDefaultEditor   Edit
      ,  -   OnCreate,
    OnChange  OnClick (  ,   ) 
     Edit   .   
             .
    ,   ,      
       OnGetCellText,      
        "" . }
  if CompareText(PropertyEditor.GetName, 'ONGETCELLTEXT') = 0 then
  begin
    PropertyEditor.Edit;
    {   ,    
          }
    Continue := False;
  end;
end;

procedure TGridEditor.ShowCollectionEditor(ACollection: TCollection);
var
{$IFDEF EX_D5_UP}
  List: TDesignerSelectionList;
{$ELSE}
  List: TComponentList;
{$ENDIF}
begin
  FCollection := ACollection;
  {   ,     
       }
{$IFDEF EX_D5_UP}
  List := TDesignerSelectionList.Create;
{$ELSE}
  List := TComponentList.Create;
{$ENDIF}
  try
    List.Add(Self.Component);
    GetComponentProperties(List, [tkClass], Self.Designer, FindCollectionEditor);
  finally
    List.Free;
  end;
end;

procedure TGridEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
{$IFDEF VER90}
    0: if EditGridColumns(TCustomGridView(Component)) then Designer.Modified;
{$ELSE}
    0: ShowCollectionEditor(TCustomGridView(Component).Columns);
{$ENDIF}
    1: if EditGridHeader(TCustomGridView(Component)) then Designer.Modified;
  end;
end;

function TGridEditor.GetVerb(Index: Integer): AnsiString;
begin
  case Index of
    0: Result := 'Columns Editor...';
    1: Result := 'Header Editor...';
  end;
end;

function TGridEditor.GetVerbCount: Integer;
begin
  Result := 2;
end;

{ TGridColumnsProperty }

procedure TGridColumnsProperty.Edit;
begin
  if EditGridColumns(TGridColumns(GetOrdValue).Grid) then Modified;
end;

function TGridColumnsProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paReadOnly];
end;

{ TGridHeaderProperty }

procedure TGridHeaderProperty.Edit;
begin
  if EditGridHeader(TGridHeaderSections(GetOrdValue).Header.Grid) then Modified;
end;

function TGridHeaderProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paReadOnly];
end;

{ TDBGridFieldNameProperty }

function TDBGridFieldNameProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paValueList, paSortList, paMultiSelect];
end;

procedure TDBGridFieldNameProperty.GetValues(Proc: TGetStrProc);
var
  Grid: TCustomDBGridView;
  Values: TStringList;
  I: Integer;
begin
  Grid := TDBGridColumn(GetComponent(0)).Grid;
  if (Grid <> nil) and (Grid.DataLink.DataSet <> nil) then
  begin
    Values := TStringList.Create;
    try
      Grid.DataLink.DataSet.GetFieldNames(Values);
      for I := 0 to Values.Count - 1 do Proc(Values[I]);
    finally
      Values.Free;
    end;
  end;
end;

procedure Register;
begin
  RegisterComponents('Extended', [TGridView]);
  RegisterComponents('Extended', [TInspector]);

  RegisterComponents('Extended', [TDBGridView]);
  
  RegisterComponentEditor(TGridView, TGridEditor);
  RegisterPropertyEditor(TypeInfo(TGridHeaderSections), TGridHeader, 'Sections', TGridHeaderProperty);

{$IFDEF VER90}
  RegisterPropertyEditor(TypeInfo(TGridColumns), TGridView, 'Columns', TGridColumnsProperty);
{$ENDIF}

  RegisterComponentEditor(TDBGridView, TGridEditor);
  RegisterPropertyEditor(TypeInfo(string), TDBGridColumn, 'FieldName', TDBGridFieldNameProperty);
end;

end.
